CONFIGMODE_CALLBACKS = CONFIGMODE_CALLBACKS or {}

if not CONFIGMODE_CALLBACKS then
	CONFIGMODE_CALLBACKS = {}
end

local chatWindowWasLocked = {}
CONFIGMODE_CALLBACKS["Blizzard - Chat Windows"] = function(action)
	if action == "ON" then
		wipe(chatWindowWasLocked)
		for index = 1, NUM_CHAT_WINDOWS do
			local frame = _G["ChatFrame".. index]
			local shown, locked, docked = select(7, GetChatWindowInfo(index))
			if locked and (docked == 1 or (shown and not docked)) then
				chatWindowWasLocked[frame] = true
				FCF_SetLocked(frame, nil)
			end
		end
	elseif action == "OFF" then
		for frame in pairs(chatWindowWasLocked) do
			FCF_SetLocked(frame, true)
		end
	end
end

local focusFrameWasLocked
CONFIGMODE_CALLBACKS["Blizzard - Focus Frame"] = function(action)
	if action == "ON" then
		focusFrameWasLocked = FocusFrame_IsLocked()
		if focusFrameWasLocked then
			FocusFrame_SetLock(false)
		end
	elseif action == "OFF" and focusFrameWasLocked then
		FocusFrame_SetLock(true)
		focusFrameWasLocked = nil
	end
end

local watchFrameWasLocked
CONFIGMODE_CALLBACKS["Blizzard - Watch Frame"] = function(action)
	if action == "ON" then
		watchFrameWasLocked = WatchFrame.locked
		if watchFrameWasLocked then
			WatchFrame_Unlock(WatchFrame)
		end
	elseif action == "OFF" and watchFrameWasLocked then
		WatchFrame_Lock(WatchFrame)
		watchFrameWasLocked = nil
	end
end

local battlefieldMinimapWasLocked
local battlefieldMinimapWasHidden
CONFIGMODE_CALLBACKS["Blizzard - Battlefield Minimap"] = function(action)
	if not BattlefieldMinimap then return end
	if action == "ON" then
		battlefieldMinimapWasHidden =	not BattlefieldMinimap:IsShown()
		battlefieldMinimapWasLocked = BattlefieldMinimapOptions.locked
		if battlefieldMinimapWasHidden then
			BattlefieldMinimap:Show()
		end
		if battlefieldMinimapWasLocked then
			BattlefieldMinimapOptions.locked = false
		end
	elseif action == "OFF" then
		if battlefieldMinimapWasHidden then
			BattlefieldMinimap:Hide()
			battlefieldMinimapWasHidden = nil
		end
		if battlefieldMinimapWasLocked then
			BattlefieldMinimapOptions.locked = true
			battlefieldMinimapWasLocked = nil
		end
	end
end
